


#define	DEFTIMERPLAYREC	8	// Okres (w 10ms) co ktry zapisywany/odczytaywany jest stan regulatorw w eeprom
							// okres nie moe by krszy ni 70ms (DEFTIMERPLAYREC = 7)
							// Przy okresie 100ms, na AtMega328 mozna zapisa 14 sekund (140 / 10) bez kompresji


/********************************************************************************/
/*								ZMIANY											*/
/********************************************************************************/
// 
// V1.1						led ST podczas zapisuj pokazuje czas prbkowania
// V1.0	2014-04-20 17:50	pierwsza wersja
//


/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1
#define	false	FALSE
#define	true	TRUE
#define	False	FALSE
#define	True	TRUE


#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC


#define	CNT0_PRESCALER_0		0
#define	CNT0_PRESCALER_1		1
#define	CNT0_PRESCALER_8		2
#define	CNT0_PRESCALER_64		3
#define	CNT0_PRESCALER_256		4
#define	CNT0_PRESCALER_1024		5
#define	CNT0_PRESCALER_T0faling	6
#define	CNT0_PRESCALER_T0rising	7

#define	CNT1_PRESCALER_0		0
#define	CNT1_PRESCALER_1		1
#define	CNT1_PRESCALER_8		2
#define	CNT1_PRESCALER_64		3
#define	CNT1_PRESCALER_256		4
#define	CNT1_PRESCALER_1024		5
#define	CNT1_PRESCALER_T1faling	6
#define	CNT1_PRESCALER_T1rising	7

#define	CNT2_PRESCALER_0		0
#define	CNT2_PRESCALER_1		1
#define	CNT2_PRESCALER_8		2
#define	CNT2_PRESCALER_32		3
#define	CNT2_PRESCALER_64		4
#define	CNT2_PRESCALER_128		5
#define	CNT2_PRESCALER_256		6
#define	CNT2_PRESCALER_1024		7



#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define	BAUD	250000
#include <util/setbaud.h>							// Uart 0
//#define	BAUD1	9600
//#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>								// Tryby upienia
#include <avr/power.h>								// Wyaczanie peryferii



//---------------------------------------------------------------------------------------
/*
// Interrupt Vectors
// Interrupt Vector 0 is the reset vector.
#define INT0_vect         _VECTOR(1)   // External Interrupt Request 0
#define INT1_vect         _VECTOR(2)   // External Interrupt Request 1
#define PCINT0_vect       _VECTOR(3)   // Pin Change Interrupt Request 0
#define PCINT1_vect       _VECTOR(4)   // Pin Change Interrupt Request 0
#define PCINT2_vect       _VECTOR(5)   // Pin Change Interrupt Request 1
#define WDT_vect          _VECTOR(6)   // Watchdog Time-out Interrupt
#define TIMER2_COMPA_vect _VECTOR(7)   // Timer/Counter2 Compare Match A
#define TIMER2_COMPB_vect _VECTOR(8)   // Timer/Counter2 Compare Match A
#define TIMER2_OVF_vect   _VECTOR(9)   // Timer/Counter2 Overflow
#define TIMER1_CAPT_vect  _VECTOR(10)  // Timer/Counter1 Capture Event
#define TIMER1_COMPA_vect _VECTOR(11)  // Timer/Counter1 Compare Match A
#define TIMER1_COMPB_vect _VECTOR(12)  // Timer/Counter1 Compare Match B 
#define TIMER1_OVF_vect   _VECTOR(13)  // Timer/Counter1 Overflow
#define TIMER0_COMPA_vect _VECTOR(14)  // TimerCounter0 Compare Match A
#define TIMER0_COMPB_vect _VECTOR(15)  // TimerCounter0 Compare Match B
#define TIMER0_OVF_vect   _VECTOR(16)  // Timer/Couner0 Overflow
#define SPI_STC_vect      _VECTOR(17)  // SPI Serial Transfer Complete
#define USART_RX_vect     _VECTOR(18)  // USART Rx Complete
#define USART_UDRE_vect   _VECTOR(19)  // USART, Data Register Empty
#define USART_TX_vect     _VECTOR(20)  // USART Tx Complete
#define ADC_vect          _VECTOR(21)  // ADC Conversion Complete
#define EE_READY_vect     _VECTOR(22)  // EEPROM Ready
#define ANALOG_COMP_vect  _VECTOR(23)  // Analog Comparator
#define TWI_vect          _VECTOR(24)  // Two-wire Serial Interface
#define SPM_READY_vect    _VECTOR(25)  // Store Program Memory Read

void* tim_handler;
ISR(TIMER2_COMP_vect,ISR_NAKED)
{
asm("ijmp"::"z"(tim_handler));
}

Skoro "program gwny" nic nie robi to przerwanie nigdy nie moe zepsu jego stanu, a wic nie ma powodu eby obsuga przerwan zapisywaa rejestry czy cokolwiek - dlatego ISR_NAKED.


*/




#define	LedSt			PD7
#define	DdrLedSt()		DDRD  |=  (1<<LedSt)
#define	SetLedSt()		PORTD &= ~(1<<LedSt)
#define	ClrLedSt()		PORTD |=  (1<<LedSt)
#define	EorLedSt()		PORTD ^=  (1<<LedSt)

#define	LedPlay			PB3
#define	DdrLedPlay()	DDRB  |=  (1<<LedPlay)
#define	ClrLedPlay()	PORTB &= ~(1<<LedPlay)
#define	SetLedPlay()	PORTB |=  (1<<LedPlay)
#define	EorLedPlay()	PORTB ^=  (1<<LedPlay)

#define	LedRec			PB4
#define	DdrLedRec()		DDRB  |=  (1<<LedRec)
#define	ClrLedRec()		PORTB &= ~(1<<LedRec)
#define	SetLedRec()		PORTB |=  (1<<LedRec)
#define	EorLedRec()		PORTB ^=  (1<<LedRec)


#define	DdrSwTempo()	PORTB |=(1<<PB5)			// Wlacz podciaganie
#define	RdSwTempo()		(PINB & (1<<PB5))	

#define	DdrSwKompr()	PORTD |=(1<<PD0)			// Wlacz podciaganie
#define	RdSwKompr()		(PIND & (1<<PD0))	

#define	DdrSwPlay()		PORTB |=(1<<PB2)			// Wlacz podciaganie
#define	RdSwPlay()		(PINB & (1<<PB2))	

#define	DdrSwRec()		PORTB |=(1<<PB1)			// Wlacz podciaganie
#define	RdSwRec()		(PINB & (1<<PB1))	

#define	DdrSw1()		PORTD |=(1<<PD2)			// Wlacz podciaganie
#define	RdSw1()			(PIND & (1<<PD2))	

#define	DdrSw2()		PORTD |=(1<<PD3)			// Wlacz podciaganie
#define	RdSw2()			(PIND & (1<<PD3))	

#define	DdrSw3()		PORTD |=(1<<PD4)			// Wlacz podciaganie
#define	RdSw3()			(PIND & (1<<PD4))	

#define	DdrSw4()		PORTD |=(1<<PD5)			// Wlacz podciaganie
#define	RdSw4()			(PIND & (1<<PD5))	

#define	DdrSw5()		PORTD |=(1<<PD6)			// Wlacz podciaganie
#define	RdSw5()			(PIND & (1<<PD6))	

#define	DdrSw6()		PORTB |=(1<<PB0)			// Wlacz podciaganie
#define	RdSw6()			(PINB & (1<<PB0))	


void Usart0_Off();
void Usart0_Init();
#define	DdrTx()			DDRD  |=  (1<<PD1);			// Port wyjsciem
#define	ClrTx()			PORTD &= ~(1<<PD1);			// wygeneruj BREAK
#define	SetTx()			PORTD |=  (1<<PD1);			// wygeneruj MAB

#define	ADCIN	6
enum{DMXCHAD1=1, DMXCHAD2, DMXCHAD3, DMXCHAD4, DMXCHAD5, DMXCHAD6};
enum{DMXCHSW1=ADCIN+1, DMXCHSW2, DMXCHSW3, DMXCHSW4, DMXCHSW5, DMXCHSW6};
byte rekord, len, kompresja=1, tempoSlow=FALSE;

#define	MEMREC	ADCIN + 1						// Wielko rekordu (potencjomentry + wszystkie SW)
// budowa rekordu (zapis i odczyt do eeprom):
// POT1						// Bajt 0
// POT2						// Bajt 1
// POT3						// Bajt 2
// POT4						// Bajt 3
// POT5						// Bajt 4
// POT6						// Bajt 5
// SW						// Bajt 6
#define	SW1REC	0x01
#define	SW2REC	0x02
#define	SW3REC	0x04
#define	SW4REC	0x08
#define	SW5REC	0x10
#define	SW6REC	0x20


#if defined(__AVR_ATmega88__) || defined(__AVR_ATmega88P__) || defined(__AVR_ATmega168__) || defined(__AVR_ATmega168P__)
	#define	MEMLEN	70							// Liczba rekordw do zapisania
#elif defined(__AVR_ATmega328P__)
	#define	MEMLEN	140							// Liczba rekordw do zapisania
#else
	#error "NIEZNANY TYP PROCESORA"
#endif
//MEMLEN = E2END / MEMREC; 


byte EElen EEMEM = 9;
byte EEmemory[ MEMLEN ][ MEMREC ] EEMEM = {	  0,  0,  0,  0,  0,  0,    1,
											 32, 32, 32, 32, 32, 32, 0x00,
											 60, 60, 60, 60, 60, 60, 0x00,
											128,128,128,128,128,128, 0x00,
											160,160,160,160,160,160, 0x00,
											200,200,200,200,200,200, 0x02,
											225,225,225,225,225,225, 0x00,
											255,255,255,255,255,255, 0x02,
											  1,  2,  3,  4,  5,  6, 0x00 };

#define	TXBUF	25								// Min liczba kanaw DMX to 24
byte NadawczyDmx[ TXBUF ] = {0};				// warto "SC"
byte PtrTxRs = TXBUF;
void SendDmx();
float srednia[ ADCIN+1 ];


void InitTimer0();
byte volatile TimerKey, TimerPlayRec;


byte FLrec=FALSE, FLplay=FALSE;

void Rec();
void RecStop();
void Play();
void PlayStop();


void Key();



//**********************************************************************//
//						Bity konfiguracyjne		 						//
//**********************************************************************//

__fuse_t __fuse __attribute__((section (".fuse"))) =
#if defined(__AVR_ATmega88__) || defined(__AVR_ATmega88P__) || defined(__AVR_ATmega168__) || defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)
{
	.extended	= 0xF9,
	.high		= 0xCC,
	.low		= 0xCE,
};
#else
	#error "NIEZNANY TYP PROCESORA w ustawieniu bitow konfiguracyjnych"
#endif


/*
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
*/



//**********************************************************************//
//						Program glowny			 						//
//**********************************************************************//
int main()
{
byte AdcCnt=0;
word DzielLed=1;


	DdrLedSt(); SetLedSt();
	DdrLedPlay(); DdrLedRec(); ClrLedPlay(); ClrLedRec();
	DdrSwPlay(); DdrSwRec();


	DdrSwTempo(); DdrSwKompr();


	InitTimer0();
	Usart0_Init();


	DdrSw1(); DdrSw2(); DdrSw3(); DdrSw4(); DdrSw5(); DdrSw6();


	ADCSRA = (1<<ADIF) | (1<<ADEN) | (1<<ADSC);	// Init konwersji AC
	ADMUX =  1;									// Mux na wejscie 1


	//--- init WDG ---
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	#define	WDTO_TIME	WDTO_120MS
	wdt_enable( WDTO_TIME );					// Blokuje IRQ !!!

	sei();


	//-----------------------------------------------------------------------------------
	//								Petla glowna
	//-----------------------------------------------------------------------------------
	while( 1 )
		{
		wdt_reset();


		Key(); Rec(); Play();


		 if ( !FLplay )									// Jeli nie trwa odtwarzanie z eeprom
			{
			//--- Obsuga ADC ---//
			if ( (ADCSRA & (1<<ADIF) ) )					// Jesli przetwarzanie zakoczone to odczyt wyniku
				{
//				NadawczyDmx[ AdcCnt+1 ] = ADCH;				// "+1" bo na zerze jest sygna "SC"
#define WAGA 0.9
				srednia[ AdcCnt ] = srednia[ AdcCnt ] * WAGA + (1-WAGA) * ADCH;	
				NadawczyDmx[ AdcCnt+1 ] = srednia[ AdcCnt ];// "+1" bo na zerze jest sygna "SC"
				
				if ( ++AdcCnt == ADCIN ) AdcCnt = 0;

				ADMUX = AdcCnt | (1<<REFS0) | (1<<ADLAR);	// MUX = AdcCnt, ref = Vcc, ADLAR = 1)
				ADCSRA |= (1<<ADIF);
				ADCSRA = (7<<ADPS0) | (1<<ADSC) | (1<<ADEN);// Start konwersji z podzielnikiem 128
				}

			if ( !RdSw1() ) { NadawczyDmx[ ADCIN+1 ] = 255; } else { NadawczyDmx[ ADCIN+1 ] = 0; }
			if ( !RdSw2() ) { NadawczyDmx[ ADCIN+2 ] = 255; } else { NadawczyDmx[ ADCIN+2 ] = 0; }
			if ( !RdSw3() ) { NadawczyDmx[ ADCIN+3 ] = 255; } else { NadawczyDmx[ ADCIN+3 ] = 0; }
			if ( !RdSw4() ) { NadawczyDmx[ ADCIN+4 ] = 255; } else { NadawczyDmx[ ADCIN+4 ] = 0; }
			if ( !RdSw5() ) { NadawczyDmx[ ADCIN+5 ] = 255; } else { NadawczyDmx[ ADCIN+5 ] = 0; }
			if ( !RdSw6() ) { NadawczyDmx[ ADCIN+6 ] = 255; } else { NadawczyDmx[ ADCIN+6 ] = 0; }
			}


		//--- Wysanie ramki DMX ---//
		if ( PtrTxRs >= TXBUF )
			{
			SendDmx();
			if ( !(--DzielLed) )
				{
				DzielLed = 500;
				if ( !FLplay && !FLrec ) EorLedSt();		// Jeli nie trwa odtwarzanie lub zapis igaj dioda
				}
			}



		}


}


//-------------------------------------------------------------------------
void Rec()
{
byte x, sw=0;

	if ( !FLrec ) return;					// Jeli nie trwa zapis to wyjdz

	if ( TimerPlayRec ) return;				// Jeli timer liczy to wyjd
	EorLedSt();
	switch ( kompresja )					// ustaw nastpny okres
		{
		case 1: TimerPlayRec = DEFTIMERPLAYREC; break;
		case 2:	TimerPlayRec = DEFTIMERPLAYREC * 2;	break;
		case 4:	TimerPlayRec = DEFTIMERPLAYREC * 4;	break;
		}
	if ( tempoSlow )						// Jeli zworka zaoona
		{
		TimerPlayRec <<= 1;					// tempo wolne (czas mnoymy przez 2)
		}


	//----- kompresja -----//
	for (x=0; x<MEMREC; x++)
		{ 
		eeprom_write_byte( &EEmemory[ rekord ][ x ], NadawczyDmx[ x+1 ] );
		}
	if ( !RdSw1() ) sw |= SW1REC;
	if ( !RdSw2() ) sw |= SW2REC;
	if ( !RdSw3() ) sw |= SW3REC;
	if ( !RdSw4() ) sw |= SW4REC;
	if ( !RdSw5() ) sw |= SW5REC;
	if ( !RdSw6() ) sw |= SW6REC;
	eeprom_write_byte( &EEmemory[ rekord ][ MEMREC-1 ], sw );


	rekord++; if ( rekord >= MEMLEN ) RecStop();	// nastpne pole
}


//-------------------------------------------------------------------------
void RecStop()
{
	FLrec = FALSE;
	ClrLedRec();

	eeprom_write_byte( &EElen, rekord-1 );			// Dlugosc zapisu zapisu

}


//-------------------------------------------------------------------------
void Play()
{
byte x, sw, dana=0, d0, d2, danaN;
static byte FLdziel=0;


	if ( !FLplay ) return;				// Jeli nie trwa odtwarzanie to wyjdz
	if ( TimerPlayRec ) return;			// Jeli timer liczy to wyjd
	EorLedSt();

	TimerPlayRec = DEFTIMERPLAYREC;		// ustaw nastpny okres (odtwarzamy dwa razy szybciej bo jest aproksymacja)
	if ( tempoSlow )				// Jeli zworka zaoona
		{
		TimerPlayRec <<= 1;				// tempo wolne (czas mnoymy przez 2)
		}


	if ( rekord >= len ) { PlayStop(); return; }	// Gdy znacznik END - zatrzymaj odtwarzanie
	sw = eeprom_read_byte( &EEmemory[ rekord ][ MEMREC ] );
	if ( sw & SW1REC ) { NadawczyDmx[ DMXCHSW1 ] = 255; } else { NadawczyDmx[ DMXCHSW1 ] = 0; }
	if ( sw & SW2REC ) { NadawczyDmx[ DMXCHSW2 ] = 255; } else { NadawczyDmx[ DMXCHSW2 ] = 0; }
	if ( sw & SW3REC ) { NadawczyDmx[ DMXCHSW3 ] = 255; } else { NadawczyDmx[ DMXCHSW3 ] = 0; }
	if ( sw & SW4REC ) { NadawczyDmx[ DMXCHSW4 ] = 255; } else { NadawczyDmx[ DMXCHSW4 ] = 0; }
	if ( sw & SW5REC ) { NadawczyDmx[ DMXCHSW5 ] = 255; } else { NadawczyDmx[ DMXCHSW5 ] = 0; }
	if ( sw & SW6REC ) { NadawczyDmx[ DMXCHSW6 ] = 255; } else { NadawczyDmx[ DMXCHSW6 ] = 0; }


	switch( kompresja )
		{
		case 1:
			//----- dekompresja -----//
			for (x=0; x<MEMREC; x++)
				{ 
				NadawczyDmx[ x+1 ] = eeprom_read_byte( &EEmemory[ rekord ][ x ] );
				}
			rekord++; if ( rekord >= MEMLEN ) PlayStop();			// nastpny rekord
			break;
		case 2:
			//----- dekompresja -----//
			for (x=0; x<MEMREC; x++)
				{ 		
				dana = eeprom_read_byte( &EEmemory[ rekord ][ x ] );
				danaN = eeprom_read_byte( &EEmemory[ rekord+1 ][ x ] );
				if ( (FLdziel & 1) == 1 )
					{
					dana = (dana + danaN) >> 1;		// urednianie
					}
				NadawczyDmx[ x+1 ] = dana;
				}
			if ( (FLdziel & 1) == 1 )
				{
				rekord++; if ( rekord >= MEMLEN-1 ) PlayStop();			// nastpny rekord
				}
			++FLdziel;
			break;
		case 4:
			//----- dekompresja -----//
			for (x=0; x<MEMREC; x++)
				{ 		
				d0 = eeprom_read_byte( &EEmemory[ rekord ][ x ] );
				danaN = eeprom_read_byte( &EEmemory[ rekord+1 ][ x ] );	// SW czytamy z wyprzedzeniem, wic nie bedzie problemu z interpolacj, ale odczyt skoczy si o jeden rekord wczeniej
				d2 = (d0 + danaN) >> 1;										// aproksymacja
				switch( FLdziel & 3 )
					{
					case 0:
					dana = d0;
					break;
				case 1:
					dana = (d0+d2) >> 1;
					break;
				case 2:
					dana = d2;
					break;
				case 3:
					dana = (danaN+d2) >> 1;
					break;
					}
					NadawczyDmx[ x+1 ] = dana;
				}
			if ( (FLdziel & 3) == 3 )
				{
				rekord++; if ( rekord >= MEMLEN-1 ) PlayStop();			// nastpny rekord
				}
			++FLdziel;
			break;
			}
}


//-------------------------------------------------------------------------
void PlayStop()
{
	FLplay = FALSE;
	ClrLedPlay();
}


//-------------------------------------------------------------------------
void Key()
{
static byte memSwPlay=TRUE, memSwRec=TRUE;


	if ( TimerKey ) return;				// Jeli timer liczy to wyjd
	TimerKey = 10;						// ustaw nastpne 100ms


	if ( !RdSwKompr() && !RdSwTempo() )		// kompresja ON, tempo ON
		{
		kompresja = 1;						// kompresja 1:1
		tempoSlow = FALSE;
		}
	else if ( RdSwKompr() && !RdSwTempo() )	// kompresja OFF, tempo ON 
		{
		kompresja = 2;						// kompresja 2:1
		tempoSlow = FALSE;
		}
	else if ( !RdSwKompr() && RdSwTempo() )	// kompresja ON, tempo OFF 
		{
		kompresja = 4;						// kompresja 4:1
		tempoSlow = FALSE;
		}
	else 									// kompresja OFF, tempo OFF 
		{
		kompresja = 4;						// kompresja 4:1
		tempoSlow = TRUE;
		}



	if ( (memSwPlay != RdSwPlay()) && !FLrec )	// Jeli stan przycisku zmienil sie i nie trwa zapis
		{
		memSwPlay = RdSwPlay();					// Zapamietaj nowy stan
		if ( !RdSwPlay() )						// Jeli nacinito PLAY
			{
			if ( FLplay )						// i trwa odtwarzanie
				{
				PlayStop();
				}
			else								// jesli nie odtwarza
				{
				rekord = 0; FLplay = TRUE;		// rozpocznij odtwarzanie i zatrzymaj zapis
				len = eeprom_read_byte( &EElen );
				SetLedPlay();
				}
			}
		}



	if ( (memSwRec != RdSwRec()) && !FLplay )	// Jeli stan przycisku zmienil sie i nie trwa zapis
		{
		memSwRec = RdSwRec();					// Zapamietaj nowy stan
		if ( !RdSwRec() )						// Jeli nacinito REC
			{
			if ( FLrec )						// i trwa zapis
				{
				RecStop();						// to przerwij
				}
			else								// jesli nie zapisuje
				{
				rekord = 0, FLrec = TRUE;		// rozpocznij zapis
				SetLedRec();
				}
			}
		}
}


//-------------------------------------------------------------------------
//					Init timer 0
//-------------------------------------------------------------------------
void InitTimer0()
{
	TCCR0A = 0x0;
	TCCR0B = 5;							// dzielnik 1024
	TCNT0 = 78;							// 10ms ( 8000000 / 1024 / 78 )
	TIMSK0 |= (1<<TOIE0);				// Zezwolenie na IRQ od przepelnienia timera
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0
//----------------------------------------------------------------------//
INTERRUPT( TIMER0_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
	TCNT0 = 78;

//TODO: przerwania co 10ms
// zapis rekordu trwa 70ms

	if ( TimerKey ) TimerKey--;			// Zmniejszaj timer do zera
	if ( TimerPlayRec ) TimerPlayRec--;

}


//----------------------------------------------------------------------//
void SendDmx()
{
	// Program gwny generuje BREAK i MAB po czym wyle dane (wpis do UDR0)
	DdrTx();							// Port wyjsciem				// DDRD  |=  (1<<PD1);	
	Usart0_Off();						// wycz UARTA
	ClrTx(); _delay_us(200);			// wygeneruj BREAK				// PORTD &= ~(1<<PD1); _delay_us(200);
	SetTx(); _delay_us(88);				// wygeneruj MAB				// PORTD |=  (1<<PD1); _delay_us(88);
	Usart0_Init();						// wcz UARTA
	UDR0 = NadawczyDmx[ PtrTxRs=0 ];	// Wpisz do nadajnika pierwszy znak (start transmisji)
}


//------------------------------------------------------------------//
//				Init USART 0										//
//------------------------------------------------------------------//
void Usart0_Init()
{
	UBRR0H = 0;
	#if F_CPU == 8000000
	UBRR0L = 1;			// 250kb dla 8MHz
	#elif F_CPU == 16000000
	UBRR0L = 3;			// 250kb dla 16MHz
	#else
		#error "Zla czestotliwoc F_CPU"
	#endif
	UCSR0A = 0;
	UCSR0C = (1<<USBS0) | (3<<UCSZ00);					// Set frame format: 8n2
	UCSR0B = (1<<TXEN0)	| (1<<TXCIE0);					// Enable transmitter i Waczenie przerwa nadawczych
}


//------------------------------------------------------------------//
//				Wylaczenie USART 0									//
//------------------------------------------------------------------//
void Usart0_Off()
{
	UCSR0B = 0;
}


//----------------------------------------------------------------------//
//				Przerwanie nadawcze od uarta
//----------------------------------------------------------------------//
#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
#define USART_TX_vect     _VECTOR(20)  /* USART Tx Complete */
//----------------------------------------------------------------------//
SIGNAL(USART_TX_vect)		// Musi byc ISR lub SIGNAL a nie INTERUPT
{
	 PtrTxRs++;							// Wskanik na nastpny znak
	 if ( PtrTxRs < TXBUF )				// Jeli s jeszcze znaki do wysania
		{
		UDR0 = NadawczyDmx[ PtrTxRs ];	// Wpisz do nadajnika
		}
}


//----------------------------------------------------------------------//



